package com.ademicon.controller;

import javax.ws.rs.Consumes;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;

import com.ademicon.model.ContratoModel;
import com.ademicon.model.ContratoResponse;
import com.ademicon.service.ContratoService;

@Path("/contrato")
public class ContratoController {

    private static ContratoService contratoService = new ContratoService();

    @POST
    @Path("/incluir")
    @Consumes(MediaType.APPLICATION_JSON)
    @Produces(MediaType.APPLICATION_JSON)
    public Response doPost(ContratoModel contrato) throws Exception {

        try {

            ContratoResponse contratoModel = contratoService.incluir(contrato);

            return Response.status(Status.CREATED).entity(contratoModel).build();

        } catch (Exception e) {
            return Response.status(Status.INTERNAL_SERVER_ERROR).build();
        }
    }

    @PUT
    @Path("/upload/chassi/{chassi}")
    @Consumes(MediaType.APPLICATION_JSON)
    @Produces(MediaType.APPLICATION_JSON)
    public Response doUpload(@PathParam(value = "chassi") String chassi, String arquivo) throws Exception {
        try {
            ContratoResponse contratoResponse = contratoService.upload(chassi, arquivo);
            return Response.status(Status.OK).entity(contratoResponse).build();

        } catch (Exception e) {
            return Response.status(Status.INTERNAL_SERVER_ERROR).build();
            
        }
    }
}
