package com.ademicon.repository.auth;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;

import com.ademicon.model.auth.AccessModel;
import com.ademicon.service.ConnectionService;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;

public class AccessRepository {
    private static Connection conn = null;
    private static PreparedStatement statement = null;
    private static ResultSet rs = null;

    public AccessModel find() throws Exception {
        try {
            String queryString = "SELECT PARAMETRO, VALOR_STR FROM ADE_006_PARM_CRED_VEIC WHERE PARAMETRO IN ('PLACETI_URL_BASE', 'PLACETI_URL_TOKEN', 'PLACETI_USER_TOKEN')";
            conn = ConnectionService.getConnection();
            statement = conn.prepareStatement(queryString);
            rs = statement.executeQuery();
            String json = "{";
            while (rs.next()) {
                json += "\"" + rs.getString("PARAMETRO") + "\":\"" + rs.getString("VALOR_STR") + "\",";
            }
            json = json.substring(0, json.lastIndexOf(",")) + "}";
            ObjectMapper mapper = new ObjectMapper();
            mapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);

            return mapper.readValue(json, AccessModel.class);

        } catch (Exception e) {
            throw new Exception(e.getMessage());
        } finally {
            try {
                if (rs != null)
                    rs.close();
            } catch (Exception e) {
            }
            try {
                if (statement != null)
                    statement.close();
            } catch (Exception e) {
            }
            try {
                if (conn != null)
                    conn.close();
            } catch (Exception e) {
            }
        }
    }

}
