package com.ademicon.repository.auth;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

import com.ademicon.model.auth.TokenModel;
import com.ademicon.service.ConnectionService;

public class TokenRepository {
    private static Connection conn = null;
    private static PreparedStatement statement = null;
    private static ResultSet rs = null;

    public Integer save(TokenModel token) throws Exception {
        try {
            String queryString = "UPDATE ADE_006_TOKEN_CONTROL SET ACCESS_TOKEN = ?, EXPIRES_IN = ? WHERE API = 'PLACETI'";
            conn = ConnectionService.getConnection();
            statement = conn.prepareStatement(queryString);
            statement.setString(1, token.getAccess_token());
            statement.setString(2, token.getExpires_in().toString().substring(0, 19));
            return statement.executeUpdate();

        } catch (Exception e) {
            throw new Exception();

        } finally {
            try {
                if (rs != null)
                    rs.close();
            } catch (Exception e) {
            }
            try {
                if (statement != null)
                    statement.close();
            } catch (Exception e) {
            }
            try {
                if (conn != null)
                    conn.close();
            } catch (Exception e) {
            }
        }
    }

    public TokenModel find() throws Exception {
        try {
            String queryString = "SELECT * FROM ADE_006_TOKEN_CONTROL WHERE API = 'PLACETI'";
            conn = ConnectionService.getConnection();
            statement = conn.prepareStatement(queryString);
            rs = statement.executeQuery();

            TokenModel newTokenModel = new TokenModel();
            if (rs.next()) {
                newTokenModel.setAccess_token(rs.getString("ACCESS_TOKEN"));
                LocalDateTime localDateTime = getLocalDateTime(rs.getString("EXPIRES_IN"));
                newTokenModel.setExpires_in(localDateTime);
            }
            return newTokenModel;

        } catch (Exception e) {
            throw new Exception(e.getMessage());

        } finally {
            try {
                if (rs != null)
                    rs.close();
            } catch (Exception e) {
            }
            try {
                if (statement != null)
                    statement.close();
            } catch (Exception e) {
            }
            try {
                if (conn != null)
                    conn.close();
            } catch (Exception e) {
            }
        }
    }

    private LocalDateTime getLocalDateTime(String localDateTimeString) {
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd'T'HH:mm:ss");
        LocalDateTime localDateTime = LocalDateTime.of(1900, 12, 31, 12, 0, 0);
        if (localDateTimeString.length() > 0) {
            localDateTime = LocalDateTime.parse(localDateTimeString.substring(0, 19), formatter);
        }
        return localDateTime;
    }
}
