package com.ademicon.service;

import java.util.List;

import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.core.GenericType;
import javax.ws.rs.core.MediaType;

import com.ademicon.model.MunicipioModel;
import com.ademicon.model.auth.AccessModel;
import com.ademicon.service.auth.AccessService;
import com.ademicon.service.auth.TokenService;

public class MunicipioService {

    private static AccessService accessService = new AccessService();
    private static TokenService tokenService = new TokenService();

    public List<MunicipioModel> list(String uf) throws Exception {

        try {

            AccessModel accessModel = accessService.find();
            String token = tokenService.getToken();
            return ClientBuilder.newBuilder().build()
                    .target(accessModel.getPlaceti_url_base() + "/api/v1/enderecamento/municipios/" + uf)
                    .request(MediaType.APPLICATION_JSON)
                    .header("Authorization", "Bearer " + token)
                    .header("Accept", "application/json")
                    .get(new GenericType<List<MunicipioModel>>() {
                    });

        } catch (Exception e) {
            System.out.println(e);
            throw new Exception(e.getMessage());

        }

    }

}
